using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Data;
using System.Threading;


using DShowNET;
using DShowNET.Device;

namespace DirectShowTest 
{

	public class DSCapture  : System.Windows.Forms.Form , ISampleGrabberCB
	{
		private bool active = false;		//튮tO
		private bool capturedFlag = false;	//Lv`̏ItO
		private bool updatedFlag = false;   //rbg}bv̍XVtO
		

		private ArrayList captureDevices;//JfoCẌꗗD

		private IBaseFilter captureFilter; //\[XtB^

		private IGraphBuilder graphBuilder; //{IȃtB^Ot}l[W

		private IVideoWindow videoWindow; //I[i[EBhËʒuTCYȂǂ̐ݒp̃C^tF[XD
		private IMediaControl mediaControl;//f[^̃Xg[~ÖړA|[YA~Ȃǂ̏p̃C^tF[XD
		private IMediaEventEx mediaEvent; //DirectShowCxgp̃C^tF[X
		
		private ICaptureGraphBuilder2 captureGraphBuilder;//rfILv`ҏWp̃\bhLv`Otr_
		private ISampleGrabber sampleGrabber; //tB^OtʂX̃f[^擾p̃C^tF[XD 
		private IBaseFilter grabFilter; //Grabber Filter̃C^tF[XD

		private VideoInfoHeader videoInfoHeader;//rfIC[W̃tH[}bgLq\
	
		private const int WS_CHILD = 0x40000000;		//VideoWindow̑D
		private const int WS_CLIPCHILDREN = 0x02000000; //iWin32APICreateWindowExƓl̂̂𗘗p\Dj

		public const int WM_GRAPHNOTIFY = 0x00008001;	//DirectShowCxg̔Windows bZ[W.

		private byte[] frameArray;//Lv`t[f[^p̔z	
		private delegate void CaptureDone();//Î~Lv`ȈsfQ[h
		private Bitmap capturedBitmap = null;//Lv`t[f[^p̃rbg}bv

		private ISpecifyPropertyPages specifyPropertyPages; //USBJ̏ڍאݒy[Wɗp
		private Thread propertyThread; //ڍאݒy[W\p̃Xbh

		CaptureForm parentForm;//etH[
		Panel videoPanel;//_OrfIʕ\ۂ̃pl		
		int videoNum; //ԖڂUSBLv`foCXw

		public DSCapture(CaptureForm form, Panel panel, int num)
		{
			this.active = false;
			this.parentForm = form;
			this.videoPanel = panel;
			this.videoNum = num;

			//DirectX ver 8.1ȏオɃCXg[Ă邩H
			if(! DsUtils.IsCorrectDirectXVersion())
			{
				MessageBox.Show("AvP[V̓ɂDirectX ver 8.1ȏオKvłD" );
				return;
			}

			//PCɐڑĂLv`foCXiUSBJȂ)̃Xg擾D
			if(!DsDev.GetDevicesOfCat(FilterCategory.VideoInputDevice, out captureDevices))
			{
				MessageBox.Show("rfILv`\ȃfoCX܂D");
				return;
			}

			DsDevice device = null;
			//w肳ꂽfoCXI
			device = captureDevices[this.videoNum] as DsDevice; 
			
			//Lv`pfoCXI΂ꂽH
			if(device == null)
				return;

			//DicrectShow֘Ȁ
			if(! InitVideo(device.Mon))
				return;

			//ݒ͐D
			this.active = true;
		}

		~DSCapture()
		{
			if(propertyThread != null)
			{
				propertyThread.Abort();
				propertyThread = null;
			}
			CloseInterfaces();
		}

		//DicrectShow֘Ȁ
		bool InitVideo(UCOMIMoniker moniker)
		{
			int result;

			try
			{
				//rfILv`foCXtB^̃CX^XɑΉD
				if(!CreateCaptureDevice(moniker))
					return false;

				//eCOM R|[lgĂяoCC^tF[X擾D
				if(!GetInterfaces()) 
					return false;
				
				//摜̃vr[Î~Lv`p̐ݒsD
				if(!SetupGraph())	
					return false;

				//摜vr[邽߂̕\̈Ȃǂ̐ݒD
				if(!SetupVideoWindow())
					return false;

				//vr[JnD
				result = mediaControl.Run();

				if(result < 0)
					Marshal.ThrowExceptionForHR(result);
				
				return true;
			}
			catch(Exception e)
			{
				MessageBox.Show( "rfIXg[𐳏ɓǂݍ߂܂D\r\n" + e.ToString());	
				return false;
			}
		}

		//rfILv`foCX\[XtB^̃CX^XɑΉD
		bool CreateCaptureDevice(UCOMIMoniker moniker)
		{
			object captureObject = null;
			
			try
			{
				//Lv`foCX(device)ƃ\[XtB^(captureFilter)ΉtD
				Guid guidBF = typeof(IBaseFilter).GUID;
				moniker.BindToObject(null, null, ref guidBF, out captureObject);
				captureFilter = (IBaseFilter) captureObject;
				
				//specifyPropertyPage擾iUSBJȂǂ̐ݒύX_CAOɗpj
				specifyPropertyPages = (ISpecifyPropertyPages)   captureFilter;
				captureObject = null;

				return true;
			}
			catch(Exception e)
			{
				MessageBox.Show("Lv`foCX쐬ł܂D\r\n"+ e.ToString());
				return false;
			}
			finally
			{
				if(captureObject != null)
				{
					Marshal.ReleaseComObject(captureObject);
					captureObject = null;
				}
			}
		}

		//eCOM R|[lg쐬CC^tF[X擾D
		bool GetInterfaces()
		{
			Type comType = null;
			object comObject = null;

			try
			{	
				//graphBuilder쐬D
				comType = Type.GetTypeFromCLSID(Clsid.FilterGraph);
				if(comType == null)
					throw new NotImplementedException("DirectShowFiterGraphIuWFNg쐬ł܂D");
				comObject = Activator.CreateInstance(comType);
				graphBuilder = (IGraphBuilder) comObject;
				comObject = null;

				//Lv`Otr_(captureGraphBuilder)쐬D
				comType = Type.GetTypeFromCLSID(Clsid.CaptureGraphBuilder2);
				comObject = Activator.CreateInstance(comType);
				captureGraphBuilder = (ICaptureGraphBuilder2) comObject;
				comObject = null;

				//TvOo(sampleGrabber)쐬
				comType = Type.GetTypeFromCLSID(Clsid.SampleGrabber);
				if(comType == null)
					throw new NotImplementedException("DirectShowSampleGrabberIuWFNg쐬ł܂D");
				comObject = Activator.CreateInstance(comType);
				sampleGrabber = (ISampleGrabber) comObject;
				comObject = null;

				//eC^tF[X擾D
				mediaControl = (IMediaControl) graphBuilder;
				videoWindow = (IVideoWindow) graphBuilder;
				mediaEvent = (IMediaEventEx) graphBuilder;
				//tB^Ɗ֘AtD
				grabFilter = (IBaseFilter) sampleGrabber;

				return true;
			}
		
			catch (Exception e)
			{
				MessageBox.Show("C^tF[X̎擾Ɏs܂D\r\n" + e.ToString());
				return false;	
			}

			finally
			{
				//COM\[X
				if(comObject !=null)
				{
					Marshal.ReleaseComObject(comObject);
					comObject = null;
				}
			}
		}

		//摜̃vr[Î~Lv`p̐ݒsD
		bool SetupGraph()
		{
			int result;
		
			try
			{
				//captureGraphBuilderiLv`Otr_jgraphBuilderitB^Ot}l[WjɒǉD
				result = captureGraphBuilder.SetFiltergraph(graphBuilder);
				if(result < 0) Marshal.ThrowExceptionForHR(result);
 
				//captureFilter(\[XtB^)graphBuilderitB^Ot}l[WjɒǉD
				result = graphBuilder.AddFilter(captureFilter, "Video Capture Device");
				if(result < 0) Marshal.ThrowExceptionForHR(result);
				
				//Lv`rfIf[^̃tH[}bgݒD
				AMMediaType amMediaType = new AMMediaType();
				amMediaType.majorType = MediaType.Video;
				amMediaType.subType = MediaSubType.RGB24;
				amMediaType.formatType = FormatType.VideoInfo; 
				
				result = sampleGrabber.SetMediaType(amMediaType);
				if(result < 0) Marshal.ThrowExceptionForHR(result);
				
				//grabFilter(ϊtB^)graphBuilderitB^Ot}l[WjɒǉD
				result = graphBuilder.AddFilter(grabFilter, "Frame Grab Filter");
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				Guid pinCategory;
				Guid mediaType; 

				//Lv`tB^TvOo[tB^ɐڑD
				pinCategory = PinCategory.Capture;
				mediaType = MediaType.Video;
				result = captureGraphBuilder.RenderStream(ref pinCategory, ref mediaType, 
					captureFilter, null, grabFilter);
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				//Lv`tB^ftHg̃_tB^ifBXvCɏójɐڑDivr[j
				pinCategory = PinCategory.Preview;
				mediaType = MediaType.Video;
				result = captureGraphBuilder.RenderStream(ref pinCategory, ref mediaType, 
					captureFilter, null, null);				
				if(result < 0) Marshal.ThrowExceptionForHR(result);
				

				//t[Lv`̐ݒ肪mFD
				amMediaType = new AMMediaType();
				result = sampleGrabber.GetConnectedMediaType(amMediaType);
				if(result < 0) Marshal.ThrowExceptionForHR(result);
				if((amMediaType.formatType != FormatType.VideoInfo) || (amMediaType.formatPtr == IntPtr.Zero))
					throw new NotSupportedException("Lv`(Grab)łȂfBAtH[}bgłD");

				//Lv`rfIf[^̃tH[}bgCvideoInfoHeader쐬D
				videoInfoHeader = 
					(VideoInfoHeader) Marshal.PtrToStructure(amMediaType.formatPtr, typeof(VideoInfoHeader));
				Marshal.FreeCoTaskMem(amMediaType.formatPtr);
				amMediaType.formatPtr = IntPtr.Zero;
			
				//tB^ʂTvobt@ɃRs[Ȃ悤Ɏw肷D
				result = sampleGrabber.SetBufferSamples(false);
				//Tvi1t[j󂯎tB^~悤Ɏw肷D
				if(result == 0) result = sampleGrabber.SetOneShot(false);
				//R[obN֐̗p~D
				if(result == 0) result = sampleGrabber.SetCallback(null, 0);

				if(result < 0) Marshal.ThrowExceptionForHR(result);

				return true;
			}
			catch(Exception e)
			{
				MessageBox.Show("tB^[Ot̐ݒɎs܂D" + e.ToString());
				return false;
			}
			
		}

		//摜vr[邽߂̕\̈Ȃǂ̐ݒD
		bool SetupVideoWindow()
		{
			int result;

			try
			{
				//vr[f\plwD
				result = videoWindow.put_Owner(videoPanel.Handle);			
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				//rfI\̈̃X^CwD
				result = videoWindow.put_WindowStyle(WS_CHILD | WS_CLIPCHILDREN);
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				//rfIpl̃TCYύXD
				ResizeVideoWindow();
				
				//_tB^̏o͂D
				result = videoWindow.put_Visible(DsHlp.OATRUE);
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				//mediaEvent(DirectShowCxg)WM_GRAPHNOTIFY(WindowsbZ[W)ɑΉtD 
				result= mediaEvent.SetNotifyWindow(this.Handle, WM_GRAPHNOTIFY, IntPtr.Zero);
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				return true;
			}

			catch(Exception e)
			{
				MessageBox.Show("rfIEChEi\̈j̏Ɏs܂D\r\n" +e.ToString());
				return false;
			}
		}

		//rfIEChEi\̈j̃TCYύXD
		private void ResizeVideoWindow()
		{
			if(videoWindow != null)
			{
				Rectangle rect = videoPanel.ClientRectangle;
				videoWindow.SetWindowPosition(0,0,rect.Right,rect.Bottom);
			}
		}

		//Î~̃Lv`JnD
		public bool StartGrabber()
		{
			int result;

			if(sampleGrabber == null) return false;

			if(frameArray == null)
			{
				//Lv`t[f[^̃TCYݒ肷D
				int size = videoInfoHeader.BmiHeader.ImageSize;		
				if ((size < 1000) || (size > 16000000)) return false; //TCYKH	
				frameArray = new byte [size + 64000]; 
			}

			Image pre = null;
			
			pre = parentForm.PictureBoxImage;
			parentForm.PictureBoxImage =  null;

			if(pre != null)
				pre.Dispose();

			capturedFlag = false;

			try	
			{
				
				//rfIf[^̃TvOɗpR[obN \bhw肷D
					//	 ISampleGrabberCB C^[tFCXւ̃|C^
					//			 nullw肷ƃR[obN
					//	0->ISampleGrabberCB.SampleCB \bh𗘗p 	
					//			1->ISampleGrabberCB.BufferCB \bh𗘗p
				result = sampleGrabber.SetCallback( this, 1 );
			}
			catch(Exception e)
			{
				MessageBox.Show(e.ToString());
			}
			return true;
		}


		//Windows bZ[W̏
		protected override void WndProc(ref Message m)
		{
			if(m.Msg == WM_GRAPHNOTIFY)
			{
				if(mediaEvent == null)
					this.OnGraphNotify();
				return;
			}	
			base.WndProc(ref m);
		}

		//DirectShowCxg̏
		public void OnGraphNotify()
		{
			DsEvCode code;
			int param1, param2, result =0;
			
			while(result == 0)
			{
				result = mediaEvent.GetEvent(out code,out param1, out param2, 0);
				if(result < 0) break;
				result = mediaEvent.FreeEventParams(code, param1, param2);
			}
			
		}

		//t[Lv`ɌĂяoR[obN֐
		int ISampleGrabberCB.SampleCB(double SampleTime, IMediaSample pSample)
		{
			return 0;
		}
	
		//t[Lv`ɌĂяoR[obN֐
		int ISampleGrabberCB.BufferCB(double SampleTime, IntPtr pBuffer, int BufferLength)
		{
			//ɃR[obNĂяoĂ邩CframeArrayĂȂΏID
			if(capturedFlag || (frameArray == null)) 
			{
				return 0;
			}
			
			capturedFlag = true;
			//̃TvOꂽf[^(pBuffer)z(frameArray)ɃRs[D
			if((pBuffer != IntPtr.Zero) && (BufferLength > 1000) && (BufferLength <= frameArray.Length))
				Marshal.Copy(pBuffer, frameArray, 0, BufferLength);
			
			try
			{	
				//CaptureDonefQ[hĂяoD
				this.BeginInvoke(new CaptureDone(this.OnCaptureDone));
			}
			catch(Exception e)
			{
				MessageBox.Show(e.ToString());
			}
			return 0;
		}

		//Lv`f[^̔zԓɌŒ肵Crbg}bvɕϊD 
		void OnCaptureDone()
		{
			try
			{
				int result;
				if(sampleGrabber == null) return;

				//R[obN֐̗p~
				result = sampleGrabber.SetCallback(null, 0);

				//t[f[^̃TCY擾
				int width = videoInfoHeader.BmiHeader.Width;
				int height = videoInfoHeader.BmiHeader.Height;

				//width4̔{łȂꍇwidthheight̒lKłȂꍇ͏ID
				if( ((width & 0x03) != 0) || (width < 32) || (width > 4096) || (height < 32) || (height> 4096) )
					return;

				//stride(1C̃f[^TCY(byte)=width* 3(RGB))ݒD
				int stride = width * 3;

				//zframeArraỹAhXCԓŌŒ肷D
				GCHandle gcHandle = GCHandle.Alloc(frameArray, GCHandleType.Pinned);
				
				int addr = (int) gcHandle.AddrOfPinnedObject();
				addr += (height - 1) * stride;
				
				//frameArrayi[AhXCrbg}bvf[^쐬D
				Bitmap bitmap = new Bitmap(width,height,-stride,PixelFormat.Format24bppRgb, (IntPtr) addr);
				capturedBitmap = new Bitmap(width,height,-stride,PixelFormat.Format24bppRgb, (IntPtr) addr);
				gcHandle.Free();
				frameArray = null;
				
				Image pre = null;

				//ʏɃLv`摜\D
			
				pre = parentForm.PictureBoxImage;
				parentForm.PictureBoxImage =  bitmap;
				

				if(pre != null) pre.Dispose();
				
				//XVD
				updatedFlag = true;

				return;
			}
			catch(Exception e)
			{
				MessageBox.Show("t[̃Lv`iGrabjɎs܂D" + e.ToString());
			}
		}

		//COMC^tF[X̉s
		public void CloseInterfaces()
		{
			try
			{
				if(mediaControl != null)
				{
					mediaControl.Stop();
					Thread.Sleep(100);
					mediaControl = null;
				}

				if(mediaEvent != null)
				{
					mediaEvent.SetNotifyWindow(IntPtr.Zero, WM_GRAPHNOTIFY, IntPtr.Zero);
					mediaEvent = null;
				}

				if(videoWindow != null)
				{
					videoWindow.put_Visible(DsHlp.OAFALSE);
					videoWindow.put_Owner(IntPtr.Zero);
					videoWindow = null;
				}

				if(grabFilter != null) grabFilter = null;

				if(sampleGrabber != null)
				{
					Marshal.ReleaseComObject(sampleGrabber);
					sampleGrabber = null;
				}

				if(captureGraphBuilder != null)
				{
					Marshal.ReleaseComObject(captureGraphBuilder);
					captureGraphBuilder = null;
				}

				if(graphBuilder != null)
				{
					Marshal.ReleaseComObject(graphBuilder);
					graphBuilder = null;
				}

				if(captureFilter != null)
				{
					captureFilter.Stop();
					Marshal.ReleaseComObject(captureFilter);
					captureFilter = null;
				}

				if(captureDevices != null)
				{
					foreach(DsDevice d in captureDevices)
					{
						d.Dispose();
					}
					captureDevices = null;
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("C^tF[X̏IɎs܂D"+ e.ToString());
			}
		}

		//ɍsꂽH
		public bool isActive
		{
			get {return this.active;}
		}

		//Î~̃Lv`IXVH
		public bool isUpdated
		{
			get{return this.updatedFlag;}
			set{this.updatedFlag = value;}
		}

		//Lv`Î~擾
		public Bitmap CapturedBitmap
		{
			get{return this.capturedBitmap;}
		}

		//Lv`foCX̐ݒ_CAOJD
		public void ShowPropertyPages()
		{		
			DsUtils.ShowCapPinDialog(captureGraphBuilder, captureFilter, this.Handle);
		}
	
		//Lv`foCX̏ڍאݒ_CAOJD
		public void ShowDetailPropertyPages()
		{
			propertyThread = new Thread(new ThreadStart(this.ShowDetailPropertyWorker));
			propertyThread.Start();
		}
		
		public void ShowDetailPropertyWorker()
		{

			DsCAUUID cauuid = new DsCAUUID();

			if(specifyPropertyPages == null) return;

			try
			{
				int handle = specifyPropertyPages.GetPages( out cauuid );
				if ( handle != 0 ) Marshal.ThrowExceptionForHR( handle);

				object o = specifyPropertyPages;

				handle = OleCreatePropertyFrame( this.Handle, 30, 30, null, 1,
					ref o, cauuid.cElems, cauuid.pElems, 0, 0, IntPtr.Zero );
			}
			finally
			{
				if( cauuid.pElems != IntPtr.Zero )
					Marshal.FreeCoTaskMem( cauuid.pElems );
			}
			return;
		}
		
		// ---------------- DLL Imports --------------------
		[DllImport("olepro32.dll", CharSet=CharSet.Unicode, ExactSpelling=true) ]
		private static extern int OleCreatePropertyFrame( 
			IntPtr hwndOwner, int x, int y,
			string lpszCaption, int cObjects,
			[In, MarshalAs(UnmanagedType.Interface)] ref object ppUnk,
			int cPages,	IntPtr pPageClsID, int lcid, int dwReserved, IntPtr pvReserved);

	}
}
