using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Data;
using System.Threading;


using DShowNET;
using DShowNET.Device;

namespace DirectShowTest 
{

	public class DSCaptureMovie {

		private bool active;//튮tO
			
		private ArrayList captureDevices;//JfoCẌꗗD
		private IBaseFilter captureFilter; //\[XtB^
		private IGraphBuilder graphBuilder; //{IȃtB^Ot}l[W

		private ICaptureGraphBuilder2 captureGraphBuilder;//rfILv`ҏWp̃\bhLv`Otr_

		private IVideoWindow videoWindow; //I[i[EBhËʒuTCYȂǂ̐ݒp̃C^tF[XD
		private IMediaControl mediaControl;//f[^̃Xg[~ÖړA|[YA~Ȃǂ̏p̃C^tF[XD
		private IMediaEventEx mediaEvent; //DirectShowCxgp̃C^tF[X

		private const int WS_CHILD = 0x40000000;		//VideoWindow̑D
		private const int WS_CLIPCHILDREN = 0x02000000; //iWin32APICreateWindowExƓl̂̂𗘗p\Dj

		public const int WM_GRAPHNOTIFY = 0x00008001;	//DirectShowCxg̔Windows bZ[W.
		
		CaptureForm parentForm;//etH[
		Panel videoPanel;//_OrfIʕ\ۂ̃pl
		
		int videoNum; //ԖڂUSBLv`foCXw

		public DSCaptureMovie(CaptureForm form, Panel panel, int num)
		{
			this.active = false;
			this.parentForm = form;
			this.videoPanel = panel;
			this.videoNum = num;

			//DirectX ver 8.1ȏオɃCXg[Ă邩H
			if(! DsUtils.IsCorrectDirectXVersion())
			{
				MessageBox.Show("AvP[V̓ɂDirectX ver 8.1ȏオKvłD" );
				return;
			}

			//PCɐڑĂLv`foCXiUSBJȂ)̃Xg擾D
			if(!DsDev.GetDevicesOfCat(FilterCategory.VideoInputDevice, out captureDevices))
			{
				MessageBox.Show("rfILv`\ȃfoCX܂D");
				return;
			}

			DsDevice device = null;
			//w肳ꂽfoCXID
			device = captureDevices[this.videoNum] as DsDevice; 
			
			//Lv`pfoCXI΂ꂽH
			if(device == null)
				return;

			//DicrectShow֘Ȁ
			if(! InitVideo(device.Mon))
				return;
			
			//ݒ͐D
			this.active = true;
		}

		~DSCaptureMovie()
		{
			CloseInterfaces();
		}

		//DicrectShow֘Ȁ
		bool InitVideo(UCOMIMoniker moniker)
		{
			int result;

			try
			{
				//rfILv`foCXtB^̃CX^XɑΉD
				if(!CreateCaptureDevice(moniker))
					return false;

				//eCOM R|[lgĂяoCC^tF[X擾D
				if(!GetInterfaces()) 
					return false;
				
				//摜̃vr[Ƙ^p̐ݒD
				if(!SetupGraph())	
					return false;

				//摜vr[邽߂̕\̈Ȃǂ̐ݒD
				if(!SetupVideoWindow())
					return false;

				//vr[Ƙ^𓯎ɊJnD
				result = mediaControl.Run();

				if(result < 0)
					Marshal.ThrowExceptionForHR(result);
				
				return true;
			}
			catch(Exception e)
			{
				MessageBox.Show( "rfIXg[𐳏ɓǂݍ߂܂D\r\n" + e.ToString());	
				return false;
			}
		}

		//rfILv`pfoCXtB^̃CX^XɑΉD
		bool CreateCaptureDevice(UCOMIMoniker moniker)
		{
			object captureObject = null;
			
			try
			{
				//Lv`foCX(device)ƃ\[XtB^(captureFilter)ΉtD
				Guid guidBF = typeof(IBaseFilter).GUID;
				moniker.BindToObject(null, null, ref guidBF, out captureObject);
				captureFilter = (IBaseFilter) captureObject;
				captureObject = null;
				return true;
			}
			catch(Exception e)
			{
				MessageBox.Show("Lv`foCX쐬ł܂D\r\n"+ e.ToString());
				return false;
			}
			finally
			{
				if(captureObject != null)
				{
					Marshal.ReleaseComObject(captureObject);
					captureObject = null;
				}
			}
		}

		//eCOM R|[lg쐬CC^tF[X擾D
		bool GetInterfaces()
		{
			Type comType = null;
			object comObject = null;

			try
			{
				//graphBuilder쐬D
				comType = Type.GetTypeFromCLSID(Clsid.FilterGraph);
				if(comType == null)
					throw new NotImplementedException("DirectShowFiterGraphIuWFNg쐬ł܂D");
				comObject = Activator.CreateInstance(comType);
				graphBuilder = (IGraphBuilder) comObject;
				comObject = null;

				//Lv`Otr_(captureGraphBuilder)쐬D
				comType = Type.GetTypeFromCLSID(Clsid.CaptureGraphBuilder2);
				comObject = Activator.CreateInstance(comType);
				captureGraphBuilder = (ICaptureGraphBuilder2) comObject;
				comObject = null;

				//graphBuilderCeC^tF[X擾D
				mediaControl = (IMediaControl) graphBuilder;
				videoWindow = (IVideoWindow) graphBuilder;
				mediaEvent = (IMediaEventEx) graphBuilder;


				return true;
			}
		
			catch (Exception e)
			{
				MessageBox.Show("C^tF[X̎擾Ɏs܂D\r\n" + e.ToString());
				return false;	
			}

			finally
			{
				//COM\[X
				if(comObject !=null)
				{
					Marshal.ReleaseComObject(comObject);
					comObject = null;
				}
			}
		}

		//摜̃vr[⓮Lv`p̐ݒsD
		bool SetupGraph()
		{
			int result;

			IBaseFilter muxFilter = null; //̓̓Xg[C AVI tH[}bgɕϊD
			IFileSinkFilter sinkFilter = null; //fBA Xg[t@CɏރtB^D

			try
			{
				//captureGraphBuilderiLv`Otr_jgraphBuilderitB^Ot}l[WjɒǉD
				result = captureGraphBuilder.SetFiltergraph(graphBuilder);
				if(result < 0) Marshal.ThrowExceptionForHR(result);
 
				//captureFilter(\[XtB^)graphBuilderitB^Ot}l[WjɒǉD
				result =result = graphBuilder.AddFilter(captureFilter, "Video Capture Device");
				if(result < 0) Marshal.ThrowExceptionForHR(result);
				
				Guid pinCategory;
				Guid mediaType; 

				//AVI`̃rfILv`
				Guid mediaSubType = MediaSubType.Avi;

				//MUXtB^ƃt@CCgtB^ڑCLv`f[^̏o̓t@CݒD
				result = captureGraphBuilder.SetOutputFileName(ref mediaSubType, CaptureForm.DummyFileName, 
					out muxFilter, out sinkFilter);
				if(result < 0) Marshal.ThrowExceptionForHR(result);
				
				pinCategory = PinCategory.Capture;
				mediaType = MediaType.Video;

				//Lv`tB^MUXtB^ɐڑD
				result = captureGraphBuilder.RenderStream(ref pinCategory, ref mediaType, 
														captureFilter, null, muxFilter);
					
				if(result < 0) Marshal.ThrowExceptionForHR(result);
				
				//Lv`tB^ftHg̃_tB^ifBXvCɏójɐڑDivr[j
				pinCategory = PinCategory.Preview;
				mediaType = MediaType.Video;
				result = captureGraphBuilder.RenderStream(ref pinCategory, ref mediaType, 
					captureFilter, null, null);				
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				return true;
			}
			catch(Exception e)
			{
				MessageBox.Show("tB^[Ot̐ݒɎs܂D" + e.ToString());
				return false;
			}
			finally
			{
				//pCOMIuWFNgD
				if(muxFilter != null) 
				{
					Marshal.ReleaseComObject(muxFilter);
					muxFilter = null;
				}
				if(sinkFilter !=null)
				{
					Marshal.ReleaseComObject(sinkFilter);
					sinkFilter = null;	
				}
			}
			return true;
		}

		//摜vr[邽߂̕\̈Ȃǂ̐ݒD
		bool SetupVideoWindow()
		{
			int result;

			try
			{
				//vr[f\plwD
				result = videoWindow.put_Owner(videoPanel.Handle);			
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				//rfI\̈̃X^CݒD
				result = videoWindow.put_WindowStyle(WS_CHILD | WS_CLIPCHILDREN);
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				//rfIpl̃TCYύXD
				ResizeVideoWindow();
				
				//_tB^̏o͂D
				result = videoWindow.put_Visible(DsHlp.OATRUE);
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				return true;
			}

			catch(Exception e)
			{
				MessageBox.Show("rfIEChEi\̈j̏Ɏs܂D\r\n" +e.ToString());
				return false;
			}
		}

		//rfIEChEi\̈j̃TCYύXD
		void ResizeVideoWindow()
		{
			if(videoWindow != null)
			{
				Rectangle rect = videoPanel.ClientRectangle;
				videoWindow.SetWindowPosition(0,0,rect.Right,rect.Bottom);
			}
		}

		//COMR|[lgȂǂ̉
		public void CloseInterfaces()
		{
			try
			{
				if(mediaControl != null)
				{
					mediaControl.Stop();
					Thread.Sleep(100);
					mediaControl = null;
				}

				if(mediaEvent != null)
				{
					mediaEvent.SetNotifyWindow(IntPtr.Zero, WM_GRAPHNOTIFY, IntPtr.Zero);
					mediaEvent = null;
				}

				if(videoWindow != null)
				{
					videoWindow.put_Visible(DsHlp.OAFALSE);
					videoWindow.put_Owner(IntPtr.Zero);
					videoWindow = null;
				}


				if(captureGraphBuilder != null)
				{
					Marshal.ReleaseComObject(captureGraphBuilder);
					captureGraphBuilder = null;
				}

				if(graphBuilder != null)
				{
					Marshal.ReleaseComObject(graphBuilder);
					graphBuilder = null;
				}

				if(captureFilter != null)
				{
					captureFilter.Stop();
					Marshal.ReleaseComObject(captureFilter);
					captureFilter = null;
				}

				if(captureDevices != null)
				{
					foreach(DsDevice d in captureDevices)
					{
						d.Dispose();
					}
					captureDevices = null;
				}


			}
			catch(Exception e)
			{
				MessageBox.Show("C^tF[X̏IɎs܂D"+ e.ToString());
			}
		}

		//ɍsꂽH
		public bool isActive
		{
			get {return this.active;}
		}

	}
}
