using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Data;
using System.Threading;

using DShowNET;
using DShowNET.Device;

namespace DirectShowTest 
{

	public class DSPlay
	{
		private bool active;//튮tO

		private IGraphBuilder graphBuilder; //{IȃtB^Ot}l[W

		private IVideoWindow videoWindow; //I[i[EBhËʒuTCYȂǂ̐ݒp̃C^tF[XD
		private IMediaControl mediaControl;//f[^̃Xg[~ÖړA|[YA~Ȃǂ̏p̃C^tF[XD
		public IMediaEventEx mediaEvent; //DirectShowCxgp̃C^tF[X
		
		CaptureForm parentForm;//etH[
		Panel videoPanel;//_OrfIʕ\ۂ̃pl

		private const int WS_CHILD = 0x40000000;		//VideoWindow̑D
		private const int WS_CLIPCHILDREN = 0x02000000; //iWin32APICreateWindowExƓl̂̂𗘗p\Dj

		public const int WM_GRAPHNOTIFY = 0x00008001;	//DirectShowCxg̔Windows bZ[W.

		public DSPlay(CaptureForm form, Panel panel)
		{
			int result;
		
			this.active = false;
			this.parentForm = form;
			this.videoPanel = panel;
	
			//DirectX ver 8.1ȏオɃCXg[Ă邩H
			if(! DsUtils.IsCorrectDirectXVersion())
			{
				MessageBox.Show("AvP[V̓ɂDirectX ver 8.1ȏオKvłD" );
				return;
			}

			try
			{
				//eCOM R|[lgĂяoCC^tF[X擾D
				if(!GetInterfaces()) return;
				
				//t@C瓮ǂݍ
				if(!SetupGraph()) return;

				//摜vr[邽߂̕\̈Ȃǂ̐ݒD
				if(!SetupVideoWindow())	return;

				//Đ
				result = mediaControl.Run();
				
				//t@C̓ǂݍ݂܂őҋ@D
				int code;
				mediaEvent.WaitForCompletion(1000, out code);

				if(result < 0)
					Marshal.ThrowExceptionForHR(result);
			}
			catch(Exception e)
			{
				MessageBox.Show( "rfIXg[𐳏ɓǂݍ߂܂D\r\n" + e.ToString());	
				return;
			}

			//ݒ͐D
			this.active = true;

			return;
		}

		~DSPlay()
		{
			CloseInterfaces();
		}

		//eCOM R|[lg쐬CC^tF[X擾D
		bool GetInterfaces()
		{
			Type comType = null;
			object comObject = null;

			try
			{
				//graphBuilder쐬D
				comType = Type.GetTypeFromCLSID(Clsid.FilterGraph);
				if(comType == null)
					throw new NotImplementedException("DirectShowFiterGraphIuWFNg쐬ł܂D");
				comObject = Activator.CreateInstance(comType);
				graphBuilder = (IGraphBuilder) comObject;
				comObject = null;

				//eC^tF[X擾D
				mediaControl = (IMediaControl) graphBuilder;
				videoWindow = (IVideoWindow) graphBuilder;
				mediaEvent = (IMediaEventEx) graphBuilder;

				return true;
			}
		
			catch (Exception e)
			{
				MessageBox.Show("C^tF[X̎擾Ɏs܂D\r\n" + e.ToString());
				return false;	
			}

			finally
			{
				//COM\[X
				if(comObject !=null)
				{
					Marshal.ReleaseComObject(comObject);
					comObject = null;
				}
			}
		}

		
		//t@C瓮ǂݍ
		bool SetupGraph()
		{
			int result;
		
			try
			{
				//t@C瓮ǂݍ݁CftHg̃_tB^ifBXvCɏójɐڑD	
				result = graphBuilder.RenderFile(CaptureForm.DummyFileName, null);
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				return true;
			}
			catch(Exception e)
			{
				MessageBox.Show("tB^[Ot̐ݒɎs܂D" + e.ToString());
				return false;
			}

		}

		//摜vr[邽߂̕\̈Ȃǂ̐ݒD
		bool SetupVideoWindow()
		{
			int result;

			try
			{
				//vr[f\plwD
				result = videoWindow.put_Owner(videoPanel.Handle);			
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				//rfI\̈̃X^CݒD
				result = videoWindow.put_WindowStyle(WS_CHILD | WS_CLIPCHILDREN);
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				//rfIpl̃TCYύXD
				ResizeVideoWindow();
				
				//_tB^̏o͂D
				result = videoWindow.put_Visible(DsHlp.OATRUE);
				if(result < 0) Marshal.ThrowExceptionForHR(result);

				//mediaEvent(DirectShowCxg)WM_GRAPHNOTIFY(WindowsbZ[W)ɑΉtD 
				result= mediaEvent.SetNotifyWindow(parentForm.Handle, WM_GRAPHNOTIFY, IntPtr.Zero);
				if(result < 0) Marshal.ThrowExceptionForHR(result);
				
				return true;
			}

			catch(Exception e)
			{
				MessageBox.Show("rfIEChEi\̈j̏Ɏs܂D\r\n" +e.ToString());
				return false;
			}
		}

		public void Stop()
		{
			if(mediaControl != null)
				mediaControl.Stop();
		}

		//rfIEChEi\̈j̃TCYύXD
		void ResizeVideoWindow()
		{
			if(videoWindow != null)
			{
				Rectangle rect = videoPanel.ClientRectangle;
				videoWindow.SetWindowPosition(0,0,rect.Right,rect.Bottom);
			}
		}

		//COMR|[lgȂǂ̉
		public void CloseInterfaces()
		{
			try
			{
				if(mediaControl != null)
				{
					mediaControl.Stop();
					Thread.Sleep(100);
					mediaControl = null;
				}

				if(mediaEvent != null)
				{
					mediaEvent.SetNotifyWindow(IntPtr.Zero, WM_GRAPHNOTIFY, IntPtr.Zero);
					mediaEvent = null;
				}

				if(videoWindow != null)
				{
					videoWindow.put_Visible(DsHlp.OAFALSE);
					videoWindow.put_Owner(IntPtr.Zero);
					videoWindow = null;
				}

				if(graphBuilder != null)
				{
					Marshal.ReleaseComObject(graphBuilder);
					graphBuilder = null;
				}

			}
			catch(Exception e)
			{
				MessageBox.Show("C^tF[X̏IɎs܂D"+ e.ToString());
			}
		}

		//ɍsꂽH
		public bool isActive
		{
			get {return this.active;}
		}

	}
}
